﻿package{
   import flash.display.Sprite;
   import flash.events.*;
   import org.papervision3d.cameras.Camera3D;
   import org.papervision3d.core.proto.DisplayObjectContainer3D;
   import org.papervision3d.render.BasicRenderEngine;
   import org.papervision3d.scenes.Scene3D;
   import org.papervision3d.view.Viewport3D;
   import org.papervision3d.objects.primitives.*;
   import org.papervision3d.materials.*;
   import org.papervision3d.materials.utils.*;
   import flash.ui.*;
   import org.papervision3d.objects.DisplayObject3D;
   import org.papervision3d.objects.parsers.Collada;

   public class Main extends Sprite{
        private var viewport:Viewport3D;
        private var scene:Scene3D;
        private var camera:Camera3D;
        private var renderer:BasicRenderEngine;

		private var cola:Collada;
		private var colaHolder:DisplayObject3D;
		private var zrot:Boolean;
		private var zspeed:Number;
		
        public function Main(){
               initPapervision3D();
			   addEventListener(Event.ENTER_FRAME, render);
			   stage.addEventListener(KeyboardEvent.KEY_DOWN , onkey);
			   stage.addEventListener(KeyboardEvent.KEY_UP , onkeyrelease);
			   zrot = false;
			   zspeed = 0;
        }
		
		private function onkey(event:KeyboardEvent):void {
            switch(event.keyCode) {
				case Keyboard.UP: 
					colaHolder.rotationX += 3;
					break;
				case Keyboard.DOWN: 
					colaHolder.rotationX -= 3;
					break;
				case Keyboard.LEFT: 
					colaHolder.rotationY += 3;
					break;
				case Keyboard.RIGHT: 
					colaHolder.rotationY -= 3;
					break;
				case 65: 
					camera.moveBackward(40);
					break;
				case 66: 
					camera.moveForward(40);
					break;
				case 32:
					zrot = true;
					break;
				default:
					trace(event.keyCode);
					break;
			}
			
			
        }
		
		private function onkeyrelease(event:KeyboardEvent):void {
            switch(event.keyCode) {
				case 32:
					zrot = false;
					break;
			}
			
			
        }

        private function initPapervision3D():void{
                viewport = new Viewport3D();
                addChild(viewport);

                scene = new Scene3D();
                camera = new Camera3D();
				camera.z = -1300;
				camera.focus = 70;
				camera.zoom = 20;
                renderer = new BasicRenderEngine();

			    setupCollada();
		}

		private function setupCollada():void {
			cola = new Collada("model.dae");
			colaHolder = new DisplayObject3D();
			colaHolder.addChild(cola);
			scene.addChild(colaHolder);
		}
		
		
		private function render(e:Event):void {
			if (zrot) {
				if (zspeed < 90) zspeed++;
				cola.roll(zspeed);
			} else {
				if (zspeed > 0) {
					zspeed--;
					cola.roll(zspeed);
				}
			}
			renderer.renderScene(scene, camera, viewport);
        }
   }
}





